module datapath(input clk,Br,rst,R0Write,ALUflag,writeMem,readMem,Wen,input[1:0] pcSel,ALU0,ALU1,input[8:0] ALUop,output zeroFlag, output[15:0] inss);
  wire[11:0] outpc,outInc,outpcSel;
  wire[2:0] outR0mux;
  wire [15:0] readData,readR0Data,imd,outALU0,outALU1,outALU,outMem,writeData,ins;
  pc p(outpcSel,Br,clk,rst,outpc);
  inc i(outpc,outInc);
  insMem im(outpc,clk,ins);
  mux12 m12(outInc, ins[11:0],{3'b000,ins[8:0]},pcSel,outpcSel);
  muxRoWrite mrw(R0Write,ins[11:9],outR0mux);
  muxALUflag maf(ALUflag,outALU,outMem,writeData);
  regFile rf(Wen,clk,ins[11:9],outR0mux,writeData,readData,readR0Data);
  signExt se(ins[11:0],imd);
  muxALU0 ma0(imd,readData,ALU0,outALU0);
  muxALU1 ma1(readR0Data,ALU1,outALU1);
  ALU a(outALU0,outALU1,ALUop,outALU);
  mem m(imd[11:0],readR0Data,clk,writeMem,readMem,outMem);
  always @(posedge clk) $display("ins : %b", ins);
  always @(posedge clk) $display("imd : %b", imd);
  always @(posedge clk) $display("data : %b", outMem);
  assign zeroFlag=(outALU==15'b0)?1:0;
  assign inss=ins;
endmodule